// ======================================================================
//
// MenuSelector.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef MENU_SELECTOR_H
#define MENU_SELECTOR_H

// ======================================================================

#include "MenuElement.h"

class MenuResourceInteger;

// ======================================================================

class MenuSelector : public MenuElement
{
protected:

	int currentSelector;

private:

	MenuSelector(void);
	MenuSelector(const MenuSelector &);
	MenuSelector &operator =(const MenuSelector &);

public:

	MenuSelector(MenuElement *parent, int maxWidth, int maxHeight, Iff *iff=NULL);
	virtual ~MenuSelector(void);

	MenuElement *getCurrentElement(void) const;

	virtual int  getCurrentSelector(void) const;
	virtual void setCurrentSelector(int newSelector);

	virtual IoResult event(IoEventStruct *event);
	virtual IoResult update(void);

	virtual void      menuDraw(int x, int y) const;
};

// ----------------------------------------------------------------------

class MenuIntSelector : public MenuSelector
{
private:

	MenuResourceInteger *menuResourceInteger;

private:

	MenuIntSelector(void);
	MenuIntSelector(const MenuIntSelector &);
	MenuIntSelector &operator =(const MenuIntSelector &);

public:

	MenuIntSelector(MenuElement *parent, int maxWidth, int maxHeight, Iff *iff=NULL);
	virtual ~MenuIntSelector(void);

	void load(Iff *iff);

	virtual int  getCurrentSelector(void) const;
	virtual void setCurrentSelector(int newSelector);
};

// ======================================================================

#endif

